/* e3c6b322a61e3b24ba99bf99fa4ddc4a */
#include "stdio.h"
#include "stdlib.h"
#include "time.h"
#include "windows.h"

#define ECHO(x) printf("%s: %d\r\n", #x, x)
#define RANDLIM 3
#define TIM_GetCounter(x)  ( (iter-timer_next+ARR)%ARR ) /* */
#define TIM_SetAutoreload( x, y )   do { ARR = y; } while(0)

typedef signed short  int16_t;
typedef signed int    int32_t;

// [===  PLL work structure ===] //
volatile struct pll_reg_t {
	int32_t outValue;
	int32_t t_capture;
	int32_t m_Error[4];
	unsigned int insensWindow;
	unsigned int signChange;
} reg_PLL;


const  int limit=1000;
static int iter=0;
static int ARR=0;
//-----------------------
int event_T = 30;
int event_shift = +8;
int event_next;
//-----------------------
int timer_T = 27;
int timer_next = 27+0;

void exti(void);
void timer(void);


// === The MAIN test program === //
int main( int argc, char** argv)
{
	DWORD nStartValue = time(NULL);
	srand(nStartValue);

	event_next = event_T+event_shift;

	ARR = timer_T;
	timer_next = 0 + ARR;

	// Initialize structure's field
	reg_PLL.outValue = timer_T;  // Value to ARR 
	reg_PLL.t_capture = 0;       // TIMx couter captured on exti
	reg_PLL.m_Error[0] = reg_PLL.m_Error[1] = reg_PLL.m_Error[2] = reg_PLL.m_Error[3] = 0;
	reg_PLL.insensWindow = RANDLIM-1;  // Insensivity window(jitter)
	reg_PLL.signChange = (reg_PLL.outValue-reg_PLL.insensWindow)/2;

	printf("MAX: %d, ", RAND_MAX ); printf("%d\r\n", rand() );
	printf("%6s; %6s; %6s;\r\n",  "Iter", "d_T", "ARR");
	for( iter=0; iter<limit; iter++) {
		if (iter==event_next) {
			exti();	
			event_next = ((iter-event_shift)/event_T+1)*event_T + event_shift + rand()%RANDLIM;
		}
		if (iter>=timer_next) {
			printf("%6d; ", iter);
			timer();
			timer_next = iter + ARR;  printf("\r\n");
		}
	}
}


// === Timer interrupt === //
void timer(void)
{
	reg_PLL.signChange = reg_PLL.outValue - (reg_PLL.outValue-reg_PLL.insensWindow)/2;
	  // Shift timeline //
	reg_PLL.m_Error[3] = reg_PLL.m_Error[2];
	reg_PLL.m_Error[2] = reg_PLL.m_Error[1];
	reg_PLL.m_Error[1] = reg_PLL.m_Error[0];
	// Calculate error
	if ( reg_PLL.t_capture <= reg_PLL.insensWindow ) {		
		// |xx!xx......I......|
		reg_PLL.m_Error[0] = 0;
	} else if ( reg_PLL.t_capture >= reg_PLL.signChange ) {	
		// |xxxxx......I..!...|
		reg_PLL.m_Error[0] = reg_PLL.t_capture - reg_PLL.outValue; // (!) negative value
	} else {
		// |xxxxx..!...I......|
		reg_PLL.m_Error[0] = reg_PLL.t_capture - reg_PLL.insensWindow ; // positive value
	}
	reg_PLL.t_capture = 0;  // Set to zero to prevent error when it do step over '0'

    //===============================================//
	// dT = ( E(n) + E(n-1) + E(n-2) + E(n-3) )/N    //
	// where N - count of E in a summ                //
	// E(x) = E(x)-dT for compensate period in past  //
	//===============================================//
	int d_T;
	d_T = (reg_PLL.m_Error[0] + reg_PLL.m_Error[1] + reg_PLL.m_Error[2] + reg_PLL.m_Error[3] )/4;
	reg_PLL.m_Error[3] -= d_T; 
	reg_PLL.m_Error[2] -= d_T; 
	reg_PLL.m_Error[1] -= d_T; 
	reg_PLL.m_Error[0] -= d_T; 
    
    reg_PLL.outValue = reg_PLL.outValue + d_T;
	printf("%6d, ", d_T);
	printf("%6d, ", reg_PLL.outValue + reg_PLL.m_Error[0] );
	TIM_SetAutoreload (TIM10, reg_PLL.outValue + reg_PLL.m_Error[0] );
	// NOTE: more element for average better for // 
	// stability, but worst for adaptation speed //
} 



// === EXTI Packed received === //
void exti(void)
{
	reg_PLL.t_capture = TIM_GetCounter(TIMx);
}

